<?

// -----------------------------------------------
// exit_local()
// -----------------------------------------------
function exit_local($print_err = 1) {
    drop_temp_table($print_err);
    exit;
}

// -----------------------------------------------
// print_error_local($str)
// -----------------------------------------------
function print_error_local($str){
    global $error;
    
    $error=$str;
    print_template('error');
    print_template('bottom');
    
    exit_local(0);
}

// -----------------------------------------------
// get_dict_tab(word)
// -----------------------------------------------
function get_dict_tab($word) {
   global $dict_table;

   if (strlen($word)>16) return $dict_table[16];
   return $dict_table[strlen($word)];
}

// -----------------------------------------------
// is_stopword($word)
// -----------------------------------------------
function is_stopword($word) {
    global $DEBUG;
    
    $query="SELECT count(*) FROM stopword WHERE word='$word'";
    if($DEBUG) echo $query,"<BR><HR>";

    if (!($res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());
  
    $row=fetch_row($res);
    free_result($res);

    return ($row[0]);
} 

// -----------------------------------------------
// drop_temp_table()
// -----------------------------------------------
function drop_temp_table($print_err) {
    global $temp_table;
    global $DEBUG;
    global $error;
    
    if ($temp_table != "") {
       $drop_temp_query="DROP TABLE $temp_table";
       if($DEBUG) echo $drop_temp_query,"<BR><HR>";

       if (!query($drop_temp_query)) {           
           if (! $print_err) {
               print('Query error: '.$drop_temp_query."\n<BR>".db_error());
	   } else {
	       $error='Query error: '.$drop_temp_query."\n<BR>".db_error();
	       print_template('error');
               print_template('bottom');
	   }       
           exit();     
       }
    }
}

?>
